<template>
  <v-container>
    <v-row>
      <v-col cols="3"> </v-col>
      <v-col cols="8" offset="1">
        <h1 class="page-header">
          Создать вакансию
        </h1>
      </v-col>
    </v-row>
    <v-row>
      <v-col cols="3">
        <div class="left-navigation">
          <div class="left-navigation-title">
            Требования <span class="count">0</span>
          </div>
          <div
            class="left-navigation-title"
            :class="{
              active: page == 'skils',
            }"
            @click="page = 'skils'"
          >
            Задачи <span class="count">{{ this.select.length }}</span>
          </div>
          <div class="left-navigation-title">
            Мы предлагаем <span class="count">0</span>
          </div>

          <div
            class="left-navigation-title"
            :class="{
              active: page == 'show',
            }"
            @click="page = 'show'"
          >
            Предпросмотр
          </div>
        </div>
      </v-col>
      <v-col cols="8" offset="1">
        <div v-show="page == 'skils'">
          <v-autocomplete
            append-icon="mdi-search-web"
            :items="jobsList"
            return-object
            item-value="title"
            item-text="title"
            v-model="selectJob"
          />
          <div class="toogle-buttons-list">
            <span
              class="toogle-button"
              v-for="skil in skils"
              :key="skil"
              :class="{ active: select.indexOf(skil) >= 0 }"
              @click="selectSkil(skil)"
              >{{ skil }}</span
            >
          </div>
        </div>
        <div v-show="page == 'show'" class="create-content">
          <h3>Чем предстоит заниматься:</h3>
          <ul>
            <li>
              <v-text-field value="Введите задачу" hide-details />
              <simple-button class="mt-3 grey">
                <v-icon color="white">mdi-plus</v-icon>
              </simple-button>
            </li>
          </ul>
          <h3>Ключевые требования:</h3>
          <ul>
            <li v-if="select.length == 0">Список пуст</li>
            <li v-for="(skill, index) in select" :key="`row-skill-${index}`">
              <v-text-field v-model="select[index]" hide-details />
            </li>
            <simple-button
              class="mt-3 grey"
              @click="
                () => {
                  this.select.push('Требование');
                }
              "
            >
              <v-icon color="white">mdi-plus</v-icon>
            </simple-button>
          </ul>
          <h3>Мы предлагаем:</h3>
          <ul>
            <li><v-text-field value="Введите преимущество" hide-details /></li>
            <simple-button class="mt-3 grey">
              <v-icon color="white">mdi-plus</v-icon>
            </simple-button>
          </ul>
          <simple-button class="mt-4" @click="saveVacancy"
            >Создать вакансию</simple-button
          >
        </div>
      </v-col>
    </v-row>
  </v-container>
</template>
<script lang="ts">
import { Component, Vue, Prop, Watch } from "vue-property-decorator";
import SimpleButton from "@/components/ui/SimpleButton.vue";
import { Vacancy } from "@/models/vacancy";

@Component({
  components: {
    SimpleButton,
  },
})
export default class VacancyNew extends Vue {
  page = "skils";
  vacancy: Vacancy | null = null;
  skils = [];

  selectJob = {};

  @Watch("selectJob")
  onChange(value: any) {
    if (this.vacancy) {
      this.vacancy.name = value.title;
    }
    this.skils = value.skils;
  }

  jobsList = [
    {
      title: "Front-end",
      skils: ["Vue.js", "JavaScript", "AngularJS", "Reackt", "Svetle"],
    },
    {
      title: "Back-end",
      skils: ["Python", "PHP", "Django", "Flask", "Laravel"],
    },
  ];

  get select() {
    if (this.vacancy) {
      return this.vacancy.skils;
    }
    return [];
  }

  mounted() {
    this.vacancy = Vacancy.new();
  }

  selectSkil(skill: string) {
    const index = this.select.indexOf(skill);
    if (index >= 0) {
      this.select.splice(index, 1);
    } else {
      this.select.push(skill);
    }
  }

  async saveVacancy() {
    await this.vacancy?.save();
    this.$router.push({
      name: "vacancy.list",
    });
  }
}
</script>

<style lang="scss">
.left-navigation {
  .left-navigation-title {
    border-radius: 20px;
    padding: 10px 22px;
    cursor: pointer;
    display: flex;
    justify-content: space-between;
    margin-bottom: 16px;
    .count {
      color: #0057b6;
    }
    &.active {
      background: #e9f1f9;
    }
  }
}
.create-content {
  color: #262c40;
  h3 {
    font-style: normal;
    font-weight: normal;
    font-size: 22px;
    line-height: 24px;
    margin: 40px 0px 20px;
    /* identical to box height, or 109% */
  }
}
.toogle-buttons-list {
  .toogle-button {
    padding: 8px 24px;
    background: #e9f1f9;
    border-radius: 42px;
    color: #262c40;
    margin-right: 16px;
    display: inline-block;
    &.active {
      background: #445fde;
      color: #ffffff;
    }

    cursor: pointer;

    -webkit-user-select: none;
  }
}
</style>
